Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1737186 - enable introspection
Summary: enable introspection
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: harfbuzz
Version: 31
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Parag Nemade
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-08-03 15:41 UTC by Matthias Clasen
Modified: 2019-11-03 00:11 UTC (History)
6 users (show)

Fixed In Version: harfbuzz-2.6.1-2.fc31 harfbuzz-2.6.1-2.fc30
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-09-21 00:02:46 UTC
Type: Bug
Embargoed:


Attachments (Terms of Use)
Configure (deleted)
2019-09-18 07:18 UTC, Mosaab Alzoubi
no flags Details
End of Make Successfully (deleted)
2019-09-18 07:20 UTC, Mosaab Alzoubi
no flags Details

Description Matthias Clasen 2019-08-03 15:41:11 UTC
Pango now has api that provides access to harfbuzz objects. It would be nice to make that available via introspection, but we can only do that if harfbuzz introspection data is available.

So, please build harfbuzz with --with-gobject --enable-introspection

Comment 1 Parag Nemade 2019-08-05 05:30:34 UTC
Tried this but its compilation error, will check more once I get time to work on this.

/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-aat-layout.h:36: syntax error, unexpected identifier in 'HB_BEGIN_DECLS' at 'HB_BEGIN_DECLS'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-aat-layout.h:431: syntax error, unexpected '*', expecting ')' or ',' in 'hb_aat_layout_get_feature_types (hb_face_t *face,' at '*'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-aat-layout.h:433: syntax error, unexpected UNSIGNED, expecting identifier or '(' or '*' in '     unsigned int *feature_count, /* IN/OUT.  May be NULL. */' at 'unsigned'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-aat-layout.h:434: syntax error, unexpected typedef-name, expecting identifier or '(' or '*' in '     hb_aat_layout_feature_type_t *features /* OUT.     May be NULL. */);' at 'hb_aat_layout_feature_type_t'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-aat-layout.h:434: syntax error, unexpected ')', expecting ',' or ';' in '     hb_aat_layout_feature_type_t *features /* OUT.     May be NULL. */);' at ')'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-aat-layout.h:442: syntax error, unexpected identifier in '  hb_ot_name_id_t name_id;' at 'hb_ot_name_id_t'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-aat-layout.h:447: syntax error, unexpected '}' in '} hb_aat_layout_feature_selector_info_t;' at '}'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-aat-layout.h:452: syntax error, unexpected '*', expecting ')' or ',' in 'hb_aat_layout_feature_type_get_selector_infos (hb_face_t *face,' at '*'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-aat-layout.h:454: syntax error, unexpected UNSIGNED, expecting identifier or '(' or '*' in '            unsigned int start_offset,' at 'unsigned'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-aat-layout.h:455: syntax error, unexpected UNSIGNED, expecting identifier or '(' or '*' in '            unsigned int *selector_count, /* IN/OUT.  May be NULL. */' at 'unsigned'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-aat-layout.h:456: syntax error, unexpected '*', expecting ',' or ';' in '            hb_aat_layout_feature_selector_info_t *selectors, /* OUT.     May be NULL. */' at '*'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-aat-layout.h:457: syntax error, unexpected ')', expecting ',' or ';' in '            unsigned int *default_index /* OUT.     May be NULL. */);' at ')'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-ot-shape.h:47: syntax error, unexpected '*', expecting ')' or ',' in 'hb_ot_shape_plan_collect_lookups (hb_shape_plan_t *shape_plan,' at '*'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-ot-shape.h:49: syntax error, unexpected typedef-name, expecting identifier or '(' or '*' in '      hb_set_t *lookup_indexes /* OUT */);' at 'hb_set_t'
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/hb-ot-shape.h:49: syntax error, unexpected ')', expecting ',' or ';' in '      hb_set_t *lookup_indexes /* OUT */);' at ')'
hb-buffer.cc:698: Warning: HarfBuzz: unknown annotation: xconstructor
hb-face.cc:184: Warning: HarfBuzz: unknown annotation: xconstructor
hb-font.cc:519: Warning: HarfBuzz: unknown annotation: xconstructor
hb-font.cc:1338: Warning: HarfBuzz: unknown annotation: xconstructor
hb-map.cc:43: Warning: HarfBuzz: unknown annotation: xconstructor
hb-ot-name.cc:55: Warning: HarfBuzz: unexpected annotation: out
hb-set.cc:43: Warning: HarfBuzz: unknown annotation: xconstructor
hb-shape-plan.cc:162: Warning: HarfBuzz: unknown annotation: xconstructor
hb-unicode.cc:155: Warning: HarfBuzz: unknown annotation: xconstructor
g-ir-scanner: link: /bin/sh ../libtool --mode=link --tag=CC gcc -o /var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/tmp-introspect1duihdwk/HarfBuzz-0.0 -export-dynamic -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fexceptions -fstack-protector-strong -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1 -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection /var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/tmp-introspect1duihdwk/HarfBuzz-0.0.o -L. libharfbuzz.la libharfbuzz-gobject.la -lgio-2.0 -lgobject-2.0 -Wl,--export-dynamic -pthread -lgmodule-2.0 -lglib-2.0 -Wl,-z,relro -Wl,--as-needed -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld -Bsymbolic-functions
libtool: link: gcc -o /var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/tmp-introspect1duihdwk/.libs/HarfBuzz-0.0 -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fexceptions -fstack-protector-strong -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1 -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection /var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/tmp-introspect1duihdwk/HarfBuzz-0.0.o -Wl,--export-dynamic -pthread -Wl,-z -Wl,relro -Wl,--as-needed -Wl,-z -Wl,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld -Bsymbolic-functions -Wl,--export-dynamic  -L. ./.libs/libharfbuzz.so ./.libs/libharfbuzz-gobject.so /var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/.libs/libharfbuzz.so -lm -lfreetype -lgraphite2 -lgio-2.0 -lgobject-2.0 -lgmodule-2.0 -lglib-2.0 -pthread
/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/tmp-introspect1duihdwk/.libs/lt-HarfBuzz-0.0: error while loading shared libraries: libharfbuzz-gobject.so.0: cannot open shared object file: No such file or directory
Command '['/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/tmp-introspect1duihdwk/HarfBuzz-0.0', '--introspect-dump=/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/tmp-introspect1duihdwk/functions.txt,/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src/tmp-introspect1duihdwk/dump.xml']' returned non-zero exit status 127.
make[4]: *** [/usr/share/gobject-introspection-1.0/Makefile.introspection:156: HarfBuzz-0.0.gir] Error 1
make[4]: Leaving directory '/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src'
make[3]: *** [Makefile:2815: all-recursive] Error 1
make[3]: Leaving directory '/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src'
make[2]: *** [Makefile:1562: all] Error 2
make[2]: Leaving directory '/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3/src'
make[1]: *** [Makefile:523: all-recursive] Error 1
make[1]: Leaving directory '/var/home/parag/fedgit/harfbuzz/harfbuzz-2.5.3'
make: *** [Makefile:455: all] Error 2
error: Bad exit status from /var/tmp/rpm-tmp.jIQJLB (%build)

Comment 2 Ben Cotton 2019-08-13 17:04:08 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 3 Ben Cotton 2019-08-13 18:34:10 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to 31.

Comment 4 Parag Nemade 2019-08-16 08:13:31 UTC
I completely forgotten this due to Flock. Will have a look this weekend.

Comment 5 Mosaab Alzoubi 2019-09-17 23:02:14 UTC
Upstream built successfully without package.

Comment 6 Parag Nemade 2019-09-18 03:23:24 UTC
(In reply to Mosaab Alzoubi from comment #5)
> Upstream built successfully without package.

Can you explain what you mean by above comment please?

For the reference here, this issue has been reported to upstream https://github.com/harfbuzz/harfbuzz/issues/1912 and I tried to work on this but could not get why it is failing. I may check it again in next few days.

Comment 7 Mosaab Alzoubi 2019-09-18 07:16:23 UTC
When use (./configure --with-gobject --enable-introspection; make) on upstream, built successfully.

See screenshots.

Comment 8 Mosaab Alzoubi 2019-09-18 07:18:56 UTC
Created attachment 1616108 [details]
Configure

Comment 9 Mosaab Alzoubi 2019-09-18 07:20:22 UTC
Created attachment 1616109 [details]
End of Make Successfully

Comment 10 Jens Petersen 2019-09-18 07:35:37 UTC
Seems fine on harfbuzz-2.6.1-1 (building on f31). :)

Comment 11 Kalev Lember 2019-09-18 07:54:02 UTC
I went ahead and enabled the introspection build. The issue that was causing the introspection scanner to not find libharfbuzz-gobject.so.0 was that the spec file was removing the rpaths that the introspection scanner relies on. See https://src.fedoraproject.org/rpms/harfbuzz/c/4ab8262ad881bbbe291ed8a14ce0bfcf439aba94

Comment 12 Fedora Update System 2019-09-18 08:06:09 UTC
FEDORA-2019-25e17887a9 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-25e17887a9

Comment 13 Parag Nemade 2019-09-18 09:55:45 UTC
Thank you Mosaab and Kalev.

Comment 14 Fedora Update System 2019-09-18 10:36:19 UTC
FEDORA-2019-7cac16652c has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-7cac16652c

Comment 15 Fedora Update System 2019-09-19 02:20:29 UTC
harfbuzz-2.6.1-2.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-7cac16652c

Comment 16 Fedora Update System 2019-09-19 02:29:55 UTC
harfbuzz-2.6.1-2.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-25e17887a9

Comment 17 Fedora Update System 2019-09-21 00:02:46 UTC
harfbuzz-2.6.1-2.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2019-11-02 01:12:28 UTC
harfbuzz-2.6.1-2.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2019-11-03 00:11:06 UTC
harfbuzz-2.6.1-2.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.